<template>
  <div class="q-pa-md">
    <q-table
      title="Users"
      :rows="users"
      row-key="id"
      :columns="columns"
      :selected-rows-label="getSelectedString"
      selection="multiple"
      v-model:selected="MoreDeleteUsersData"
    >
      <template v-slot:body-cell-role="users">
        <q-td :users="users" align="left" width="20px">
          {{users.row.role.name}}
        </q-td>
      </template>
      <template v-slot:body-cell-action="users">
        <q-td :users="users" align="left" width="20px">
          <q-btn
            v-if="$isPerCrud($route.path, 'update', JSON.stringify(this.$store.state.example.userPermission))"
            color="primary"
            icon="edit"
            @click="ShowEditModal(users.row)"
            size="sm"
            danse
            class="q-ml-sm"
          />
          <q-btn
            v-if="$isPerCrud($route.path, 'delete', JSON.stringify(this.$store.state.example.userPermission))"
            color="red"
            icon="delete"
            @click="ShowDeleteModal(users.row)"
            size="sm"
            danse
            class="q-ml-sm"
          />
        </q-td>
      </template>
      <template v-slot:top>
        <q-btn
          v-if="$isPerCrud($route.path, 'write', JSON.stringify(this.$store.state.example.userPermission))"
          color="primary"
          :disable="loading"
          label="Add User"
          @click="ShowAddModal()"
        />
        <q-btn
          v-if="MoreDeleteUsersData.length"
          class="q-ml-sm"
          color="red"
          :disable="loading"
          label="Delete Users"
          @click="ShowMoreDeleteUsersModal()"
        />
        <q-space />
        <q-input
          dense
          rounded
          standout="bg-info text-white"
          v-model="search_text"
          input-class="text-right"
          class="q-ml-md"
        >
          <template v-slot:append>
            <q-icon v-if="search_text === ''" name="search" />
            <q-icon
              v-else
              name="clear"
              class="cursor-pointer"
              @click="search_text = ''"
            />
          </template>
        </q-input>
      </template>
    </q-table>

    <!-- Modallar Dialog -->
    <!-- Add Dialog -->
    <q-dialog v-model="AddModal" persistent>
      <q-card style="min-width: 350px" @keyup.enter="SendAddData" @keyup.esc="AddModalCancel()">
        <q-card-section>
          <div class="text-h6">New User</div>
        </q-card-section>

        <q-card-section class="q-pt-none">
          <div class="text-h7">Name</div>
          <q-input 
            dense 
            v-model="AddData.name" 
            autofocus 
          />
        </q-card-section>

        <q-card-section class="q-pt-none">
          <div class="text-h7">Email</div>
          <q-input
            dense 
            v-model="AddData.email" 
            autofocus 
          />
        </q-card-section>

        <q-card-section class="q-pt-none">
          <div class="text-h7">Role</div>
          <q-select 
            filled
            v-model="AddData.role_id" 
            :options="roles" 
            label="Select Roles" 
            emit-value
            map-options
          />
        </q-card-section>

        <q-card-section class="q-pt-none">
          <div class="text-h7">New Password</div>
          <q-input v-model="AddData.password" filled :type="isPwd ? 'password' : 'text'" hint="Password with toggle">
          <template v-slot:append>
            <q-icon
              :name="isPwd ? 'visibility_off' : 'visibility'"
              class="cursor-pointer"
              @click="isPwd = !isPwd"
            />
          </template>
        </q-input>
        </q-card-section>

        <q-card-section class="q-pt-none">
          <div class="text-h7">Return Password</div>
          <q-input v-model="AddData.return_password" filled :type="isPwd ? 'password' : 'text'" hint="Password with toggle">
            <template v-slot:append>
              <q-icon
                :name="isPwd ? 'visibility_off' : 'visibility'"
                class="cursor-pointer"
                @click="isPwd = !isPwd"
              />
            </template>
          </q-input>
        </q-card-section>

        <q-card-actions align="right" class="text-primary">
          <q-btn flat label="Create" @click="SendAddData"/>
          <q-btn flat label="Cancel" @click="AddModalCancel()"/>
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Add Dialog -->

    <!-- Edit Dialog -->
    <q-dialog v-model="EditModal" persistent>
      <q-card style="min-width: 350px" @keyup.enter="SendEditModal" @keyup.esc="EditModal = false">
        <q-card-section>
          <div class="text-h6">Edit User</div>
        </q-card-section>

        <q-card-section class="q-pt-none">
          <div class="text-h7">Name</div>
          <q-input 
            dense 
            v-model="EditData.name" 
            autofocus 
          />
        </q-card-section>

        <q-card-section class="q-pt-none">
          <div class="text-h7">Email</div>
          <q-input
            :disable="true" 
            dense 
            v-model="EditData.email" 
            autofocus 
          />
        </q-card-section>

        <q-card-section class="q-pt-none">
          <div class="text-h7">Role</div>
          <q-select 
            filled
            v-model="EditData.role_id" 
            :options="roles" 
            label="Select Roles" 
            emit-value
            map-options
          />
        </q-card-section>

        <q-card-section class="q-pt-none">
          <div class="text-h7">New Password</div>
          <q-input
            dense 
            :error="password_error"
            v-model="EditData.password" 
            autofocus 

          />
        </q-card-section>

        <q-card-section class="q-pt-none">
          <div class="text-h7">Return Password</div>
          <q-input
            dense 
            :error="password_error"
            v-model="EditData.return_password" 
            autofocus 
          />
        </q-card-section>

        <q-card-actions align="right" class="text-primary">
          <q-btn flat label="Update" @click="SendEditData"/>
          <q-btn flat label="Cancel" @click="EditModal = false"/>
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Edit Dialog -->

    <!-- Delete Dialog -->
    <q-dialog v-model="DeleteModal" persistent>
      <q-card style="min-width: 350px" @keyup.enter="SendDeleteData" @keyup.esc="DeleteModal = false">
        <q-card-section>
          <div class="text-h6">Delete User</div>
        </q-card-section>

        <q-card-section>
          <div class="text-h7">You agree to delete this information?</div>
        </q-card-section>
        <q-card-section>
          <div class="text-h7">Name:{{DeleteData.name}}<br> email:{{DeleteData.email}}<br> role:{{roles[DeleteData.role_id-1].label}}</div>
        </q-card-section>
        <q-card-actions align="right" class="text-primary">
          <q-btn flat color="negative" label="Delete" @click="SendDeleteData"/>
          <q-btn flat label="Cancel" @click="DeleteModal = false"/>
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End Delete Dialog -->

    <!-- More Delete Dialog -->
    <q-dialog v-model="MoreDeleteUsersModal" persistent>
      <q-card style="min-width: 350px" @keyup.enter="SendMoreDeleteUsersData" @keyup.esc="MoreDeleteUsersModal = false">
        <q-card-section>
          <div class="text-h6">Delete Users</div>
        </q-card-section>

        <q-card-section>
          <div class="text-h7">You agree to delete this informations? Count: {{MoreDeleteUsersData.length}}</div>
        </q-card-section>
        <q-card-section v-for="(user,i) in MoreDeleteUsersData" :key="i">
          <div class="text-h7">Name:{{user.name}} email:{{user.email}} </div>
        </q-card-section>
        <q-card-actions align="right" class="text-primary">
          <q-btn flat color="negative" label="Delete" @click="SendMoreDeleteUsersData"/>
          <q-btn flat label="Cancel" @click="MoreDeleteUsersModal = false"/>
        </q-card-actions>
      </q-card>
    </q-dialog>
    <!-- End more Delete Dialog -->
  </div>
</template>

<script>
import { defineComponent } from 'vue'
import axios from 'axios'
import { ref } from 'vue'


export default defineComponent({
  name: 'PageUsers',
  data() {
    return {
      permission: [],
      password_error: false,
      isPwd: true,
      search_text: '',
      roles:[],
      users: [],
      selected: [],
      columns: [
        {
          name: 'index',
          label: '#',
          field: 'index',
          align: "left",
          style: 'width: 10px',
          sortable: true
        },
        {
          name: 'name',
          field: 'name',
          label: 'User Name',
          align: 'left',
          sortable: true,
        },
        {
          name: 'email',
          field: 'email',
          label: 'Email',
          align: 'left',
          sortable: true,
        },
        {
          name: 'role',
          field: 'role',
          label: 'Role',
          align: 'left',
          sortable: true,
        },
        {
          name: 'action',
          label: 'Action',
          align: 'left',
          style: 'width: 20px !important',
        },
      ],
      AddModal: false,
      AddData: {
        id: "",
        name: "",
        email: "",
        role_id: "",
        password: "",
        return_password: ""
      },
      EditModal: false,
      EditData: null,
      DeleteModal: false,
      DeleteData: null,
      MoreDeleteUsersModal: false,
      MoreDeleteUsersData: []
    }
  },
  async mounted() {
    this.$q.loading.show()
    if(!this.$isPerCrud(this.$route.path, 'read', JSON.stringify(this.$store.state.example.userPermission))){
      this.$router.push('/').catch(() => {})
    }
    this.user()
    await this.role()
    // var data = JSON.stringify(this.$store.state.example.userPermission)
    // console.log(this.$isPerCrud(this.$route.path, "write", data))
    // var rt = this.$isPerCrud(this.$route.path, "write")
    // console.log(rt)
    //console.log(this.$store.state.example.userPermission[0]["name"])
  },

  methods: {
    async user() {
      await axios.get('http://127.0.0.1:8000/api/user/get_users').then((response) => {
        var data = response.data.data
        //console.log(response.data.data)
        
        for(var i=0;i<data.length;i++){
          var json = {
            "index": i,
            "id": data[i].id,
            "name": data[i].name,
            "email": data[i].email,
            "role": data[i].role,
            "password": "",
            "return_password": ""
          }
          this.users.push(json)
        }

      }).catch((e)=>{
        var res = e.response
        this.$q.loading.hide()
        if(res.status == 401){
          this.$e("You are not authorized")
          this.$router.push('/login').then((s) => {}).catch((e) => {})
        }else{
          this.$e("Something Errors")
        }
      })
    },
    async user1() {
      await axios.get('http://127.0.0.1:8000/api/user/get_users').then((response) => {
        var data = response.data.data
        //console.log(response.data.data)
        var users = []
        for(var i=0;i<data.length;i++){
          var json = {
            "index": i,
            "id": data[i].id,
            "name": data[i].name,
            "email": data[i].email,
            "role": data[i].role,
            "password": "",
            "return_password": ""
          }
          
          users.push(json)
        }
        this.users = users;
      }).catch((e)=>{
        var res = e.response
        this.$q.loading.hide()
        if(res.status == 401){
          this.$e("You are not authorized")
          this.$router.push('/login').then((s) => {}).catch((e) => {})
        }else{
          this.$e("Something Errors")
        }
        return false
      })
    },
    async role(){
      await axios.get('http://127.0.0.1:8000/api/role/get_roles').then((response) => {
        var data = response.data
        //console.log(response.data.data)
        if(data != null){this.$q.loading.hide()}
        for(var i=0;i<data.length;i++){
          var json = {
            "value": data[i].id,
            "label": data[i].name,
            "permission": data[i].permission,
          }
          this.roles.push(json) 
        }
      }).catch((e)=>{
        var res = e.response
        if(res.status == 401){
          this.$e("You are not authorized")
          this.$q.loading.hide()
          this.$router.push('/login').then((s) => {}).catch((e) => {})
        }else{
          this.$e("Something Errors")
        } 
      })
    },
    async role1() {
      await axios.get('http://127.0.0.1:8000/api/role/get_roles').then((response) => {
        var data = response.data.data
        //console.log(response.data.data)
        var roles = []
        for(var i=0;i<data.length;i++){
          var json = {
            "value": data[i].id,
            "label": data[i].name,
            "permission": data[i].permission,
          }
          roles.push(json)
        }
        this.roles = roles;
      }).catch((e)=>{
        var res = e.response
        this.$q.loading.hide()
        if(res.status == 401){
          this.$e("You are not authorized")
          this.$router.push('/login').then((s) => {}).catch((e) => {})
        }else{
          this.$e("Something Errors")
        }
        return false
      })
    },
    
    ShowAddModal(){
      this.AddData.role_id = this.roles[this.roles.length-1].value
      this.AddModal = true
      this.MoreDeleteUsersData = []
    },

    AddModalCancel(){
      this.AddData = {
        id: "",
        name: "",
        email: "",
        role_id: "",
        password: "",
        return_password: ""
      }
      this.AddModal = false
    },
    async SendAddData(){
      this.password_error = false
      if(this.AddData.name.length < 3){
        this.$e("The name must be at least 3 characters.")
        return 0;
      }
      if(this.AddData.email.length < 3){
        this.$e("The email must be at least 3 characters.")
        return 0;
      }
      if(this.AddData.password == "" && this.AddData.return_password == ""){
        this.$e("You not Enter Password")
        this.password_error = true
        return 0;
      }else{
        if(this.AddData.password != this.AddData.return_password){
          this.$e("You entered two password differently")
          this.password_error = true
          return 0;
        }
        if(this.AddData.name.length < 3){
          this.$e("The password must be at least 3 characters.")
          this.password_error = true
          return 0;
        } 
      }
      this.$q.loading.show()
      await axios.post("http://127.0.0.1:8000/api/user/create_user", this.AddData).then((res) => {
        //console.log(res.msg)
        if(res.status == 201){
          this.$s("Succesfully Create User Data")
          this.AddModalCancel()
        }
      }).catch((e)=>{
        this.$q.loading.hide()
        var res = e.response
        if(res.status == 401){
          this.$e("You are not authorized")
          this.$q.loading.hide()
          this.$router.push('/login').then((s) => {}).catch((e) => {})
        }else
        if(res.status == 422){
            if(res.data.errors.name){
              this.$e(res.data.errors.name[0])
            }
            if(res.data.errors.email){
              this.$e(res.data.errors.email[0])
            }
            if(res.data.errors.password){
              this.$e(res.data.errors.password[0])
            }
            if(res.data.errors.role_id){
              this.$e(res.data.errors.role_id[0])
            }
        }else{
            this.$e("Something Error")
        } 
      })
      await this.user1()
      await this.role1()
      this.$q.loading.hide()
    },

    ShowEditModal(user){
      this.MoreDeleteUsersData = []
      this.EditData={
        "index": user.index,
        "id": user.id,
        "name": user.name,
        "email": user.email,
        "role_id": user.role.id,
        "password": "",
        "return_password": ""
      }
      this.EditModal = true
    },
    async SendEditData(){
      this.password_error = false
      if(this.EditData.name.length < 3){
        this.$e("The name must be at least 3 characters.")
        return 0;
      }
      if(this.EditData.password == "" && this.EditData.return_password == ""){
        this.$i("You no update password")
      }else{
        if(this.EditData.password != this.EditData.return_password){
          this.$e("You entered two password differently")
          this.password_error = true
          return 0;
        } 
      }
      this.$q.loading.show()
      await axios.post("http://127.0.0.1:8000/api/user/update_user", this.EditData).then((res) => {
        //console.log(res.msg)
        if(res.status == 200){
          this.$s("Succesfully Update User Data")
          this.EditModal = false;
        }
      }).catch((e)=>{
        this.$q.loading.hide()
        var res = e.response
        if(res.status == 401){
          this.$e("You are not authorized")
          this.$q.loading.hide()
          this.$router.push('/login').then((s) => {}).catch((e) => {})
        }else
        if(res.status == 422){
            if(res.data.errors.name){
              this.$e(res.data.errors.name[0])
            }
            if(res.data.errors.email){
              this.$e(res.data.errors.email[0])
            }
            if(res.data.errors.password){
              this.$e(res.data.errors.password[0])
            }
            if(res.data.errors.role_id){
              this.$e(res.data.errors.role_id[0])
            }
        }else{
            this.$e("Something Error")
        } 
      })
      await this.user1()
      await this.role1()
      this.$q.loading.hide()
    },

    ShowDeleteModal(user) {
      this.MoreDeleteUsersData = []
      this.DeleteData={
        "index": user.index,
        "id": user.id,
        "name": user.name,
        "email": user.email,
        "role_id": user.role.id
      }
      this.DeleteModal = true
    },
    async SendDeleteData(){
      this.$q.loading.show()
      await axios.post("http://127.0.0.1:8000/api/user/delete_user", this.DeleteData).then((res) => {
        //console.log(res.msg)
        if(res.status == 200){
          this.$s("Succesfully Delete User")
          this.DeleteModal = false;
        }
      }).catch((e)=>{
        this.$q.loading.hide()
        var res = e.response
        if(res.status == 401){
          this.$e("You are not authorized")
          this.$q.loading.hide()
          this.$router.push('/login').then((s) => {}).catch((e) => {})
        }else
        if(res.status == 422){
            if(res.data.errors.name){
              this.$e(res.data.errors.name[0])
            }
            if(res.data.errors.email){
              this.$e(res.data.errors.email[0])
            }
            if(res.data.errors.password){
              this.$e(res.data.errors.password[0])
            }
            if(res.data.errors.role_id){
              this.$e(res.data.errors.role_id[0])
            }
        }else{
            this.$e("Something Error")
        } 
      })
      await this.user1()
      await this.role1()
      this.$q.loading.hide()
    },

    ShowMoreDeleteUsersModal(){
      this.MoreDeleteUsersModal = true
      // for(var i=0;i<this.MoreDeleteUsersData.length;i++){
      //   console.log(this.MoreDeleteUsersData[i].email)
      // }
      console.log(this.MoreDeleteUsersData)
    },
    async SendMoreDeleteUsersData(){
      if(this.MoreDeleteUsersData.length == 0){
        this.$e = "Data Emty!!!"
        return 0
      }
      this.$q.loading.show()
      await axios.post("http://127.0.0.1:8000/api/user/more_delete_user", this.MoreDeleteUsersData).then((res) => {
        //console.log(res.msg)
        if(res.status == 200){
          console.log(res)
          this.$s("Succesfully  Delete Users: "+this.MoreDeleteUsersData.length)
          this.MoreDeleteUsersModal = false;
          this.MoreDeleteUsersData = []
        }
      }).catch((e)=>{
        this.$q.loading.hide()
        var res = e.response
        if(res.status == 401){
          this.$e("You are not authorized")
          this.$q.loading.hide()
          this.$router.push('/login').then((s) => {}).catch((e) => {})
        }else
        if(res.status == 422){
            if(res.data.errors.name){
              this.$e(res.data.errors.name[0])
            }
            if(res.data.errors.email){
              this.$e(res.data.errors.email[0])
            }
            if(res.data.errors.password){
              this.$e(res.data.errors.password[0])
            }
            if(res.data.errors.role_id){
              this.$e(res.data.errors.role_id[0])
            }
        }else{
            this.$e("Something Error")
        } 
      })
      this.Delete
      await this.user1()
      await this.role1()
      this.$q.loading.hide()

    }
  },
})
</script>